function covered = overlap(start, stop, regions)
% Assume that start and stop represent a reference interval
% and that regions is an Nx2 matrix of possibly overlapping
% start and stop times.  Find the amount of time between
% start and stop that is covered by regions.

covered = 0;

% merge any overlapping regions so that we don't count
% things twice
merged = merge(regions);
% Find intersecting time between ground truth and these detections
for r = 1:size(merged, 1)
    if merged(r, 1) <= start
        % first item starts before the ground truth, so we
        % use the ground truth start time
        % last item is either the end of the current
        % detection or the end of the ground truth, whichever
        % is smaller.
        last = min(merged(r,2), stop);
        delta = last - start;
    elseif merged(r, 2) <= stop
        % current item ends before end of ground truth
        % and starts after its beginning
        delta = merged(r,2) - merged(r,1);
    else
        % current item ends after the ground truth
        delta = stop - merged(r,1);
    end
    covered = covered + delta;
end