function subset = restrictdetections(project, site, detections)
% subset = restrictdetections(project, site, detections)
% Given a set of detections, extract those releated to a specific
% project and site

projectI = strcmp(project, detections.project);
siteI = strcmp(site, detections.site);
retainI = projectI & siteI;  % entries matching site and project

% Detections associated with this project & site
fields = fieldnames(detections);
if sum(retainI)
    for fidx=1:length(fields)
        if ~isscalar(detections.(fields{fidx}))
            subset.(fields{fidx}) = detections.(fields{fidx})(retainI);
        end
    end
    subset.N = length(subset.start);
else
    % The detections passed in did not match anything.
    % Create a dummy record with the detection fields
    for fidx=1:length(fields)
        subset.(fields{fidx}) = [];
    end
    % dummy entries
    subset.project = {project};
    subset.site = {site};
    subset.N = 0;
end